import java.awt.*;
import java.applet.Applet;
import java.sql.*;

public class bookQueryApplet extends Applet
{
  // declare a few objects to be global
  Connection theConnection = null;
  Statement theStatement = null;
  Button theCheckDatabaseButton = null;
  List theBooksList = null;

  public void init()
  {
    // put up some controls
    setLayout(null);
    setSize(400,400);
    theCheckDatabaseButton = new java.awt.Button("Check database");
    theCheckDatabaseButton.setBounds(48,192,360,32);
    theCheckDatabaseButton.setFont(new Font("Dialog", Font.BOLD, 18));
    add(theCheckDatabaseButton);

    Label theBooksInDatabaseLabel = new java.awt.Label("Books in Database");
    theBooksInDatabaseLabel.setBounds(24,12,360,32);
    theBooksInDatabaseLabel.setFont(new Font("Dialog", Font.BOLD, 18));
    add(theBooksInDatabaseLabel);

    theBooksList = new java.awt.List(0, false);
    theBooksList.setBounds(30, 60, 329, 103);
    theBooksList.setFont(new Font("Dialog", Font.BOLD, 14));
    add(theBooksList);

    // connect to the database
    setupDatabase();

    //register listeners
    MyActionListener theListener = new MyActionListener();
    theCheckDatabaseButton.addActionListener(theListener);
  }

  public void destroy()
  {
    try {
      if (theStatement != null)
        theStatement.close();
      if (theConnection != null)
        theConnection.close();
    } catch (SQLException se) {
      System.err.println("SQL Exception: " + se.getMessage());
    }    
  }

  void setupDatabase()
  {
    // Load the driver
    Class theDriver = sun.jdbc.odbc.JdbcOdbcDriver.class;

    // Open the connection
    try {
      theConnection = 
        DriverManager.getConnection("jdbc:odbc:booksWholesale");
      theStatement = theConnection.createStatement();
    } catch (SQLException se) {
      System.err.println("SQL Exception: " + se.getMessage());
    }
  }

  public static void main(String args[])
  {
    // run a test routine
    System.out.println("Starting");
    bookQueryApplet theApplet = new bookQueryApplet();
    System.out.println("setting up database");
    theApplet.setupDatabase();
    System.out.println("setup done");
    try {
      ResultSet theResults = theApplet.theStatement.executeQuery(
        "SELECT title, retailPrice FROM books, publishers WHERE publisher = publishers.ID AND [ic:ccc]publishers.Imprint = 'Que'");
      while (theResults.next())
      {
        String theTitle = theResults.getString("title");
        float thePrice = theResults.getFloat("retailPrice");
        System.out.println(theTitle + " " + thePrice);
      }
    } catch (SQLException se) {
      System.err.println("SQL Exception: " + se.getMessage());
    } finally {
      theApplet.destroy();
      System.out.println("exiting");
    }
    System.exit(0);
  }

  class MyActionListener implements java.awt.event.ActionListener  
  {
    public void actionPerformed(java.awt.event.ActionEvent theEvent)
    {
      Object anObject = theEvent.getSource();
      if (anObject == theCheckDatabaseButton)
        theCheckDatabaseButton_Action(theEvent);
    }

    void theCheckDatabaseButton_Action(java.awt.event.ActionEvent theEvent)
    {
      theBooksList.removeAll();
      try {
        ResultSet theResults = theStatement.executeQuery(
          "SELECT title, retailPrice FROM books, publishers WHERE publisher = publishers.ID AND publishers.Imprint = 'Que'");
        while (theResults.next())
        {
          String theTitle = theResults.getString("title");
          float thePrice = theResults.getFloat("retailPrice");
          System.out.println(theTitle + " " + thePrice);
          theBooksList.add(theTitle + " " + thePrice);
        }
      } catch (SQLException se) {
        System.err.println("SQL Exception: " + se.getMessage());
      }
    }
  }
}
